/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef FILEMONITOR_H
#define FILEMONITOR_H

#include <config.h>
#include <map>
#include <toolkit/event_loop.h>

#ifdef HAVE_FAM_H
#include <fam.h>
#else
typedef enum FAMCodes {
    FAMChanged = 1,
    FAMDeleted = 2,
    FAMStartExecuting = 3,
    FAMStopExecuting = 4,
    FAMCreated = 5,
    FAMMoved = 6,
    FAMAcknowledge = 7,
    FAMExists = 8,
    FAMEndExist = 9
} FAMCodes;
#endif

class String;

class FileMonitorListener
{
    bool end_exist;
public:
    FileMonitorListener();
    void event(const String &filename, FAMCodes code);

    virtual void existsEvent(const String &filename, FAMCodes code);
    virtual void regularEvent(const String &filename, FAMCodes code);
};

class FileMonitor
{
    class Internal;
    Internal *i;
public:
    FileMonitor();
    ~FileMonitor();
    void addListener(FileMonitorListener *listener, const String &filename);
    void removeListener(FileMonitorListener *listener);
};

#endif
