/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#include <toolkit/toolkit.h>
#include "icons.h"

#include "icons/git-16x16.c"
#include "icons/inkscape_layer09a.c"
#include "icons/inkscape_layer10a.c"
#include "icons/line-style.c"
#include "icons/line-width.c"
#include "icons/neverball-16x16.c"

#include "icons/crystalsvg/actions_filenew.c"
#include "icons/crystalsvg/actions_filesave.c"
#include "icons/crystalsvg/actions_folder_new.c"
#include "icons/crystalsvg/actions_ok.c"
#include "icons/crystalsvg/actions_save_all.c"
#include "icons/crystalsvg/filesystems_folder.c"
#include "icons/crystalsvg/mimetypes_unknown.c"

#include "icons/gtk/clear.c"
#include "icons/gtk/go-back-ltr.c"
#include "icons/gtk/go-forward-ltr.c"

#include "icons/kicad/Add_Component.c"
#include "icons/kicad/Add_Line.c"
#include "icons/kicad/Cursor_Shape.c"
#include "icons/kicad/add_bus.c"
#include "icons/kicad/del_body.c"

#include "icons/silk/add.c"
#include "icons/silk/arrow_redo.c"
#include "icons/silk/arrow_undo.c"
#include "icons/silk/brick.c"
#include "icons/silk/cursor.c"
#include "icons/silk/delete.c"
#include "icons/silk/folder.c"
#include "icons/silk/folder_add.c"
#include "icons/silk/font.c"
#include "icons/silk/magifier_zoom_out.c"
#include "icons/silk/magnifier_zoom_in.c"
#include "icons/silk/page.c"
#include "icons/silk/page_white.c"
#include "icons/silk/page_white_add.c"
#include "icons/silk/page_white_stack.c"
#include "icons/silk/picture.c"
#include "icons/silk/tag_blue_edit.c"
#include "icons/silk/textfield_rename.c"
#include "icons/silk/vector.c"

#include "icons/wmicons_crystalclear/choice-no.c"
#include "icons/wmicons_crystalclear/choice-yes.c"
#include "icons/wmicons_crystalclear/clock.c"
#include "icons/wmicons_crystalclear/colors.c"
#include "icons/wmicons_crystalclear/configuration.c"
#include "icons/wmicons_crystalclear/game-logic.c"
#include "icons/wmicons_crystalclear/ghostview.c"
#include "icons/wmicons_crystalclear/item.c"
#include "icons/wmicons_crystalclear/keyboard.c"
#include "icons/wmicons_crystalclear/lock.c"
#include "icons/wmicons_crystalclear/mail.c"
#include "icons/wmicons_crystalclear/modules.c"
#include "icons/wmicons_crystalclear/monitoring.c"
#include "icons/wmicons_crystalclear/programs.c"
#include "icons/wmicons_crystalclear/quit.c"
#include "icons/wmicons_crystalclear/video.c"
#include "icons/wmicons_crystalclear/viewer.c"
#include "icons/wmicons_crystalclear/window-delete.c"
#include "icons/wmicons_crystalclear/window-iconify.c"
#include "icons/wmicons_crystalclear/window-maximize.c"
#include "icons/wmicons_crystalclear/window-move.c"
#include "icons/wmicons_crystalclear/window-resize.c"
#include "icons/wmicons_crystalclear/window-stick.c"
#include "icons/wmicons_crystalclear/windows.c"
#include "icons/wmicons_crystalclear/xv.c"

namespace icons {
    Icon *const git = new Icon(&icon_git16x16);
    Icon *const rotate_cw = new Icon(&icon_inkscape_layer09a);
    Icon *const rotate_ccw = new Icon(&icon_inkscape_layer10a);
    Icon *const line_style = new Icon(&icon_linestyle);
    Icon *const line_width = new Icon(&icon_linewidth);
    Icon *const neverball = new Icon(&icon_neverball16x16);

    Icon *const new_file = new Icon(&icon_crystalsvg_actions_filenew);
    Icon *const save = new Icon(&icon_crystalsvg_actions_filesave);
    Icon *const new_folder = new Icon(&icon_crystalsvg_actions_folder_new);
    Icon *const commit = new Icon(&icon_crystalsvg_actions_ok);
    Icon *const save_all = new Icon(&icon_crystalsvg_actions_save_all);
    Icon *const tree_node = new Icon(&icon_crystalsvg_filesystems_folder);
    Icon *const tree_leaf = new Icon(&icon_crystalsvg_mimetypes_unknown);

    Icon *const clear = new Icon(&icon_gtk_clear);
    Icon *const backward = new Icon(&icon_gtk_gobackltr);
    Icon *const forward = new Icon(&icon_gtk_goforwardltr);

    Icon *const object_component = new Icon(&icon_kicad_add_component);
    Icon *const object_net = new Icon(&icon_kicad_add_line);
    Icon *const crosshairs = new Icon(&icon_kicad_cursor_shape);
    Icon *const object_bus = new Icon(&icon_kicad_add_bus);
    Icon *const erase = new Icon(&icon_kicad_del_body);

    Icon *const add = new Icon(&icon_silk_add);
    Icon *const redo = new Icon(&icon_silk_arrow_redo);
    Icon *const undo = new Icon(&icon_silk_arrow_undo);
    Icon *const piece = new Icon(&icon_silk_brick);
    Icon *const cursor = new Icon(&icon_silk_cursor);
    Icon *const remove = new Icon(&icon_silk_delete);
    Icon *const folder = new Icon(&icon_silk_folder);
    Icon *const add_folder = new Icon(&icon_silk_folder_add);
    Icon *const font = new Icon(&icon_silk_font);
    Icon *const zoom_out = new Icon(&icon_silk_magifier_zoom_out);
    Icon *const zoom_in = new Icon(&icon_silk_magnifier_zoom_in);
    Icon *const page_blue = new Icon(&icon_silk_page);
    Icon *const page = new Icon(&icon_silk_page_white);
    Icon *const add_page = new Icon(&icon_silk_page_white_add);
    Icon *const pages = new Icon(&icon_silk_page_white_stack);
    Icon *const picture = new Icon(&icon_silk_picture);
    Icon *const edit_tag = new Icon(&icon_silk_tag_blue_edit);
    Icon *const input_line = new Icon(&icon_silk_textfield_rename);
    Icon *const path = new Icon(&icon_silk_vector);

    Icon *const failure = new Icon(&icon_wmicons_crystalclear_choiceno);
    Icon *const success = new Icon(&icon_wmicons_crystalclear_choiceyes);
    Icon *const time = new Icon(&icon_wmicons_crystalclear_clock);
    Icon *const color = new Icon(&icon_wmicons_crystalclear_colors);
    Icon *const tools = new Icon(&icon_wmicons_crystalclear_configuration);
    Icon *const puzzle = new Icon(&icon_wmicons_crystalclear_gamelogic);
    Icon *const search_in_files =
	new Icon(&icon_wmicons_crystalclear_ghostview);
    Icon *const favorite = new Icon(&icon_wmicons_crystalclear_item);
    Icon *const keyboard = new Icon(&icon_wmicons_crystalclear_keyboard);
    Icon *const lock = new Icon(&icon_wmicons_crystalclear_lock);
    Icon *const mail = new Icon(&icon_wmicons_crystalclear_mail);
    Icon *const generic = new Icon(&icon_wmicons_crystalclear_modules);
    Icon *const configure = new Icon(&icon_wmicons_crystalclear_monitoring);
    Icon *const package = new Icon(&icon_wmicons_crystalclear_programs);
    Icon *const quit = new Icon(&icon_wmicons_crystalclear_quit);
    Icon *const video = new Icon(&icon_wmicons_crystalclear_video);
    Icon *const magnify = new Icon(&icon_wmicons_crystalclear_viewer);
    Icon *const backspace = new Icon(&icon_wmicons_crystalclear_windowdelete);
    Icon *const window_down =
	new Icon(&icon_wmicons_crystalclear_windowiconify);
    Icon *const window_up =
	new Icon(&icon_wmicons_crystalclear_windowmaximize);
    Icon *const fullscreen = new Icon(&icon_wmicons_crystalclear_windowmove);
    Icon *const resize = new Icon(&icon_wmicons_crystalclear_windowresize);
    Icon *const attached = new Icon(&icon_wmicons_crystalclear_windowstick);
    Icon *const windows = new Icon(&icon_wmicons_crystalclear_windows);
    Icon *const eye = new Icon(&icon_wmicons_crystalclear_xv);
}
