/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef GUI_TABS_H
#define GUI_TABS_H

#include <toolkit/toolkit.h>

class MainTabBar;
class Hub;

class TabActionSet : public Toolkit::ActionSet
{
    MainTabBar &tab_bar;
    bool insert_after_current;
public:
    TabActionSet(MainTabBar &tabBar);
    void insertTab(Item *tab);
    void actionTriggered(Toolkit::Action *action);
    void update();

    Toolkit::Action nextAction;
    Toolkit::Action previousAction;

    Toolkit::Action closeAction;
    Toolkit::Action moveLeftAction;
    Toolkit::Action moveRightAction;
    Toolkit::Action closeOthersAction;
    Toolkit::Action insertAfterCurrentAction;
};

class MainTabBar : public Toolkit::TabBar
{
    Hub &hub;
    TabActionSet action_set;
    Toolkit::MenuBuilder menu_builder;

    void tabSelected();
    Toolkit::Menu *invokeContextMenu(Shadow *shadow);
public:
    MainTabBar(Toolkit::Connection &conn, Hub &hub,
	       Toolkit::Action &toggle_action);
    ~MainTabBar();
    MutableStandardInterior tabs;
    Toolkit::ActionSet *actionSet();
    void selectNewTab(Item *tab);
};

#endif
