/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#include "messages.h"


Message::Message(Type type, const String &str, int line, int column)
    : type(type), str(str), line(line), column(column)
{
}

void Messages::error(const String &str)
{
    append(Message(Message::Error, str, -1, -1));
}

void Messages::warning(const String &str)
{
    append(Message(Message::Warning, str, -1, -1));
}

void Messages::note(const String &str)
{
    append(Message(Message::Note, str, -1, -1));
}
