/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#include "nb_action.h"
#include "nb_object.h"


ConnectPathAction::ConnectPathAction(PathObject *path0,
				     PathObject *path1, Drawing *drawing)
    : Action(drawing), path0(path0), path1_old(path0->path()), path1_new(path1)
{
}

void ConnectPathAction::apply()
{
    path0->setPath(path1_new);
}

void ConnectPathAction::unapply()
{
    path0->setPath(path1_old);
}
