/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#include "objectmodel.h"
#include "util/string.h"
#include "object.h"


ObjectItem::ObjectItem(Object *object) : _object(object)
{
    if (object->children())
	setInterior(object->children()->interior());
    setCaption(object->name().capitalize());
    setIcon(object->icon());
}

Object *ObjectItem::object() const
{
    return _object;
}

/****************************************************************************/

ObjectInterior::ObjectInterior(ObjectContext *context) : _context(context)
{
}

ObjectContext *ObjectInterior::context() const
{
    return _context;
}

Item *ObjectInterior::item(unsigned int index) const
{
    return _items[index];
}

unsigned int ObjectInterior::indexOf(Item *item) const
{
    return _items.indexOf(item);
}

void ObjectInterior::replace(unsigned int index, unsigned int count,
			     const List<Item *> &items)
{
    _items.replace(index, count, items);
    ItemInterior::replace(index, count, items.count());
}
