/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef OBJECTMODEL_H
#define OBJECTMODEL_H

#include <toolkit/model_view.h>
#include "util/list.h"

class Object;
class ObjectContext;

class ObjectItem : public Item
{
    Object *const _object;
public:
    ObjectItem(Object *object);
    Object *object() const;
};

class ObjectInterior : public ItemInterior
{
    ObjectContext *const _context;
    List<Item *> _items;
public:
    ObjectInterior(ObjectContext *context);
    ObjectContext *context() const;
    void replace(unsigned int index, unsigned int count,
		 const List<Item *> &items);
protected:
    Item *item(unsigned int index) const;
    unsigned int indexOf(Item *item) const;
};

#endif
