/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef SCH_BOX_H
#define SCH_BOX_H

#include "gen_rectangular.h"
#include "sch_attribute.h"

class BoxMajorMode : public RectangularMajorMode
{
public:
    BoxMajorMode(Hub &hub);
private:
    Object *buildObject(const Metrum3 &p0, const Metrum3 &p1);
};

class BoxObject : public RectangularObject
{
public:
    BoxObject(const Metrum3 &p0, const Metrum3 &p1, Drawing *drawing);
    String name() const;
    void write(XMLWriter *writer);

    List<Attribute *> attributes() const;
    Variant attribute(const Attribute *attribute) const;
    Variant attributeDefault(const Attribute *attribute) const;
    void setAttribute(const Variant &value, const Attribute *attribute);

    int color;
    SchematicLine line;
    SchematicFill fill;
};

#endif
