/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef SCH_READXML_H
#define SCH_READXML_H

#include "xml.h"

class ObjectContext;
class SchematicLine;
class SchematicFill;

class SchematicXMLHandler : public XMLHandler
{
public:
    SchematicXMLHandler(Drawing *drawing, ObjectContext *context);
    void element(XMLElement *element, Messages &messages);

private:
    class LineXMLHandler;
    class TextXMLHandler;
    class ComponentXMLHandler;

    Drawing *const drawing;
    ObjectContext *const context;

    void read_line(SchematicLine &line, XMLElement *element);
    void read_fill(SchematicFill &fill, XMLElement *element);

    void read_arc_object(XMLElement *element);
    void read_box_object(XMLElement *element);
    void read_circle_object(XMLElement *element);
    void read_component_object(XMLElement *element);
    void read_line_object(XMLElement *element);
    void read_net_object(XMLElement *element);
    void read_path_object(XMLElement *element);
    void read_picture_object(XMLElement *element);
    void read_pin_object(XMLElement *element);
    void read_text_object(XMLElement *element);
};

#endif
