/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef ACTIONSETS_H
#define ACTIONSETS_H

#include <toolkit/menus.h>

using namespace Toolkit;

class Example;

class FileActionSet : public ActionSet
{
    Example &example;
    Action save_action;
    Action print_action;
    Action quit_action;
    MenuBuilder menu_builder;
public:
    FileActionSet(Connection &conn, Example &example);
    Menu *menu() const;
    void actionTriggered(Action *action);
};

class DocksActionSet : public ActionSet
{
    std::vector<Action *> actions;
    MenuBuilder *menu_builder;
public:
    DocksActionSet(Connection &conn);
    ~DocksActionSet();
    Menu *menu() const;
    void actionTriggered(Action *action);
};

class ViewActionSet : public ActionSet
{
    Action zoom_in_action;
    Action zoom_out_action;
    Action docks_action;
    Action tab_bar_action;
    DocksActionSet docks_action_set;
    MenuBuilder menu_builder;
public:
    ViewActionSet(Connection &conn);
    Menu *menu() const;
    void actionTriggered(Action *action);
};

class PopupActionSet : public ActionSet
{
    std::vector<Action *> actions;
    MenuBuilder *menu_builder;
public:
    PopupActionSet(Connection &conn);
    ~PopupActionSet();
    Menu *menu() const;
    void actionTriggered(Action *action);
};

#endif
