/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef EDITORS_H
#define EDITORS_H

#include <toolkit/toolkit.h>

class InputEditor : public ItemEditor
{
    std::string value;
    Toolkit::Input *input;
public:
    InputEditor();
    void paint(Toolkit::Connection &conn, X::GC gc,
	       const Toolkit::Region &region,
	       unsigned long background, X::Pixmap pixmap);
    void createWidget(Toolkit::Connection &conn);
    void deleteWidget();
    void invoke(Time time, int x, int y, int x_root, int y_root);
    void accept();
    void reset();
};

class SelectorEditor : public ItemEditor
{
    ItemInterior *const options;
    Item *selected_item;
    Toolkit::Selector *selector;
public:
    SelectorEditor(ItemInterior *options);
    void paint(Toolkit::Connection &conn, X::GC gc,
	       const Toolkit::Region &region,
	       unsigned long background, X::Pixmap pixmap);
    void createWidget(Toolkit::Connection &conn);
    void deleteWidget();
    void invoke(Time time, int x, int y, int x_root, int y_root);
    void accept();
    void reset();
};

#endif
