/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef EXAMPLE_H
#define EXAMPLE_H

#include "viewport.h"
#include "attmodel.h"
#include "actionsets.h"

class ExampleWidgets
{
    MenuBarBuilder menu_bar_builder;
    Viewport viewport;
    ViewportNavigator navigator;
    ScrollPane pane;
    Docks::Manager dock_manager;
    StatusBar status_bar;
    VContainer root_widget;

    AttributeModel attribute_model;
    PropertiesView properties_view;
    ScrollPane properties_pane;
    Docks::Dock properties_dock;

    Button button0, button1;
    HContainer button_layout;
    Docks::Dock buttons_dock;
public:
    ExampleWidgets(Connection &conn, Menu *fileMenu, Menu *viewMenu);
    Widget *rootWidget();
    Focussable *focusHandler();
    StatusBar *statusBar();
    ActionSet *fileActionSet();
    ActionSet *viewActionSet();
};

class Example : Destructible
{
    FileActionSet file_action_set;
    ViewActionSet view_action_set;
    ExampleWidgets widgets;
    X::Window window;
    InputWindowHook hook;
public:
    Example(Connection &conn, int argc, char **argv);
    void close();
};

#endif
