/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#include <stdlib.h>
#include <err.h>
#include "example.h"


int main(int argc, char **argv)
{
    if (setlocale(LC_ALL, "") == NULL)
	errx(EXIT_FAILURE, "setlocale: Request cannot be honored");

    if (!XSupportsLocale())
	errx(EXIT_FAILURE, "XSupportsLocale: Xlib functions are not capable "
			   "of operating under the current locale");

    if (XSetLocaleModifiers("") == NULL)
	errx(EXIT_FAILURE, "XSetLocaleModifiers: Invalid values given for "
			   "one or more modifier categories");

    new Example(*new Connection(NULL), argc, argv);

    EventLoop::run();

    return EXIT_SUCCESS;
}
