/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef VIEWPORT_H
#define VIEWPORT_H

#include <toolkit/navigator.h>

class ViewportScroller; /* internal */

class ViewportNavigator : public Toolkit::Navigator
{
    Toolkit::Widget *widget;
    Toolkit::NavigatorData getNavigatorData() const;
    void navigateTo(int x, int y);
public:
    ViewportNavigator(Toolkit::Widget *widget);
};

class Viewport : public Toolkit::Widget
{
    ViewportScroller *horz_scroller, *vert_scroller;
public:
    Viewport(Toolkit::Connection &conn);
    ~Viewport();
    void updateLayout();
    void paint(const Toolkit::Region &region, X::Pixmap pixmap);
};

#endif
