/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#include "mainw.h"
#include "../connection.h"

#define OUTER_PLASMA_X 6
#define OUTER_PLASMA_Y 6

using namespace Toolkit::Docks;


MainWidget::MainWidget(Connection &conn)
    : ContainerWidget(conn), mainControl(*this)
{
}

void MainWidget::updateLayout()
{
    mainControl.setDimensions(Region(x() + OUTER_PLASMA_X,
				     y() + OUTER_PLASMA_Y,
				     width() - OUTER_PLASMA_X * 2,
				     height() - OUTER_PLASMA_Y * 2));
}

void MainWidget::sizeRequirementsChanged(WidgetControl *control)
{
    SizeRequirements reqs(mainControl.sizeRequirements());
    reqs.addX(OUTER_PLASMA_X * 2);
    reqs.addY(OUTER_PLASMA_Y * 2);
    setSizeRequirements(reqs);
}

void MainWidget::paint(const Region &region, X::Pixmap pixmap)
{
    gc().setForeground(colors().dockPlasma.pixel);
    pixmap.fillRectangle(gc(), x() - region.x,
			       y() - region.y, width(), height());

    ContainerWidget::paint(region, pixmap);
}
