/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef TOOLKIT_EVENT_LOOP_H
#define TOOLKIT_EVENT_LOOP_H

#include <vector>

namespace Toolkit {

class Connection;

class EventLoop
{
public:
    static void addConnection(Connection *connection);
    static void removeConnection(Connection *connection);
    static void run();

    class Reader {
    public:
	Reader(int fd);
	~Reader();
	int const fd;
	virtual void read() = 0;
    };

    class Idler {
    public:
	Idler();
	~Idler();
	virtual void idle() = 0;
    };
private:
    static std::vector<Connection *> connections;
    static std::vector<Reader *> readers;
    static std::vector<Idler *> idlers;
};

} /* namespace Toolkit */

#endif
