/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef TOOLKIT_SELECTOR_H
#define TOOLKIT_SELECTOR_H

#include "widget.h"

class Item;
class ItemInterior;

namespace Toolkit {

class DropdownView;
class ScrollPane;
class SelectorMenu;

class Selector : public Widget, Focussable
{
    Item *selected_item;
    DropdownView *const view;
    ScrollPane *const pane;
    SelectorMenu *const menu;
    bool has_focus;
public:
    Selector(ItemInterior *choices, Connection &conn);
    ~Selector();
    Item *selectedItem() const;
    void setSelectedItem(Item *item);

    void openMenu(Time time, int global_x, int global_y);
    void closeMenu(Time time, bool select_item);

    void paint(const Region &region, X::Pixmap pixmap);

    void buttonPressEvent(Time time, int x, int y,
			  int x_root, int y_root,
			  unsigned int state, unsigned int button);
    void keyPressEvent(Time time, int x, int y, int x_root, int y_root,
		       unsigned int state, unsigned int keycode,
		       const std::string &text, KeySym keysym);
    void focusInEvent();
    void focusOutEvent();
};

} /* namespace Toolkit */

#endif
