/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef TOOLKIT_STATUSBAR_H
#define TOOLKIT_STATUSBAR_H

#include "widget.h"
#include "hotkey.h"

class Icon;

namespace Toolkit {

class StatusBarTimer; /* internal */

class StatusBar : public Widget
{
    std::string _message;
    Icon *icon;
    int _num, _denom;
    Hotkey incomplete_hotkey;
    StatusBarTimer *const timer;
public:
    StatusBar(Connection &conn);
    ~StatusBar();
    std::string message() const;
    void setMessage(const std::string &message, Icon *icon = 0);
    void setTimedMessage(long sec, long usec,
			 const std::string &message, Icon *icon = 0);
    void setProgress(int num, int denom);
    void setIncompleteHotkey(const Hotkey &hotkey);
    void paint(const Region &region, X::Pixmap pixmap);
};

} /* namespace Toolkit */

#endif
