/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef TOOLKIT_STDMODEL_H
#define TOOLKIT_STDMODEL_H

#include "model_view.h"
#include <deque>

class StandardInterior : public ItemInterior
{
    std::vector<Item *> _items;
    bool delete_items;
    Item *item(unsigned int index) const;
    unsigned int indexOf(Item *item) const;
public:
    StandardInterior(bool deleteItems = false);
    StandardInterior(const std::vector<Item *> &items,
		     bool deleteItems = false);
    StandardInterior(const std::deque<Item *> &items,
		     bool deleteItems = false);
    ~StandardInterior();
protected:
    std::vector<Item *> items() const;
    void replace(unsigned int index, unsigned int count,
		 const std::vector<Item *> &items);
};

class MutableStandardInterior : public StandardInterior
{
public:
    MutableStandardInterior(bool deleteItems = false);
    std::vector<Item *> items() const;
    void setItems(const std::vector<Item *> &items);
    void addItem(Item *item);
    void replace(unsigned int index, unsigned int count,
		 const std::vector<Item *> &items);
};

class StandardItem : public Item
{
public:
    StandardItem(const std::string &caption = std::string(), Icon *icon = 0);
    MutableStandardInterior interior;
    void setCaption(const std::string &caption);
    void setHotkey(const std::string &hotkey);
    void setIcon(Icon *icon);
    void setBold(bool bold);
    void setItalic(bool italic);
    void setEditor(ItemEditor *editor);
};

#endif
