/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef TOOLKIT_TIMER_H
#define TOOLKIT_TIMER_H

namespace Toolkit {

class Timer
{
public:
    virtual ~Timer();
    virtual void timeout() = 0;
    void set(long sec, long usec, bool repeat);
    void unset();
    bool isActive() const;
};

const struct timespec *process_timers();

} /* namespace Toolkit */

#endif
