/* Copyright (C) 2013 Roland Lutz

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */

#ifndef TOOLKIT_UTIL_REGION_H
#define TOOLKIT_UTIL_REGION_H

namespace Toolkit {

class Region
{
public:
    Region();
    Region(int x, int y, int width, int height);
    bool contains(int px, int py) const;
    bool contains(const Region &region) const;
    bool overlaps(const Region &region) const;
    Region intersection(const Region &region) const;
    Region hull(const Region &region) const;
    int x, y;
    int width, height;
};

bool operator==(const Region &r0, const Region &r1);
bool operator!=(const Region &r0, const Region &r1);

} /* namespace Toolkit */

#endif
